#!/usr/bin/env python
# -*- coding: UTF-8 -*-

def ecdl_test_resolve_order(*args):
#Auteur : Alain Guichard
#31/10/2013
#Fonction donnant les paramètres de name resolve order en doublon
#ET leur position dans la chaine.
    from creole.error import TypeEoleError, DependencyError,FileNotFound, ConfigError
    from pyeole.process import system_out
    pos = 1    #Valeur de décalage (l'index d'une liste commence à zéro) et on veut,
               #pour l'affichage à l'utilisateur, indiquer la position du doublon, cad:
               #"la position 1 correspond à l'index 0 de la liste"
    #Récupération de toutes les variables
    for arg in args:
        #Récupération des seules variables "multi"
        if arg.startswith("["):
            #Création du dico doublons
            doublons = {}
            #Déclaration des variables "multi" en liste
            ev_args = eval(arg)
            assert type(ev_args) == list
            # Initialisation du dico doublons => {'variable' : [sa première position dans la liste]}
            for i in range(len(ev_args)-1):
                doublons[ev_args[i]] =[]
                doublons[ev_args[i]].append(ev_args.index(ev_args[i])+pos)
            # Recherche des doublons
            ExisteDoublon = 'False'
            for i in range(len(ev_args)-1):
                Ch_test = ev_args[i]
                List_test = ev_args[i+1:len(arg)]
                if Ch_test in List_test:
                    ExisteDoublon = 'True'
                    #Inscription de la position de la valeur "trouvée"
                    doublons[Ch_test].append( (pos + i) + (pos + List_test.index(Ch_test)) )
            #Création du message à afficher en cas de doublons
            MessageDoublon = ""
            for i in range(len(doublons.keys())):
                if len(doublons[doublons.keys()[i]]) >1:
                    a = str(doublons.keys()[i])
                    MessageDoublon = MessageDoublon + a + " est en doublon en position "
                    for j in range(len(doublons[doublons.keys()[i]])):
                        MessageDoublon = MessageDoublon + str(doublons[doublons.keys()[i]][j]) + " "
                    MessageDoublon = MessageDoublon + "\n"
            #Affichage du message si doublons
            if ExisteDoublon and len(MessageDoublon) !=0:
                raise TypeEoleError("\n\nOnglet SAMBA\nDans l'ordre de resolution de nom le(s) parametre(s):\n%s" % MessageDoublon)
    return True

def auto2_ip_ldap(activer_client_ldap, **kw):
    from creole.error import TypeEoleError, DependencyError,FileNotFound, ConfigError
    from pyeole.process import system_out
    """ renvoie l'adresse du serveur ldap local
    pas de valeur renvoyée si on choisit un ldap distant
    """
    if activer_client_ldap == 'distant':
        raise DependencyError
    else:
        # récupération de l'adresse du service local
        return kw['ip_annuaire']

